diff -Naur newlib-1.19.0.orig/newlib/libc/string/bcmp.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/bcmp.c
--- newlib-1.19.0.orig/newlib/libc/string/bcmp.c	2005-10-28 23:21:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/bcmp.c	2011-05-17 07:25:06.789153697 +0200
@@ -6,11 +6,11 @@
 	bcmp
 
 ANSI_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	int bcmp(const void *<[s1]>, const void *<[s2]>, size_t <[n]>);
 
 TRAD_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	int bcmp(<[s1]>, <[s2]>, <[n]>)
 	const void *<[s1]>;
 	const void *<[s2]>;
@@ -35,7 +35,7 @@
 	bcmp ansi pure
 */
 
-#include <string.h>
+#include <strings.h>
 
 int
 _DEFUN (bcmp, (m1, m2, n),
diff -Naur newlib-1.19.0.orig/newlib/libc/string/bcopy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/bcopy.c
--- newlib-1.19.0.orig/newlib/libc/string/bcopy.c	2002-05-23 20:46:04.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/bcopy.c	2011-05-17 07:25:06.789153697 +0200
@@ -3,7 +3,7 @@
 	<<bcopy>>---copy memory regions
 
 ANSI_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	void bcopy(const void *<[in]>, void *<[out]>, size_t <[n]>);
 
 TRAD_SYNOPSIS
@@ -26,7 +26,7 @@
 	bcopy - pure
 */
 
-#include <string.h>
+#include <strings.h>
 
 void
 _DEFUN (bcopy, (b1, b2, length),
diff -Naur newlib-1.19.0.orig/newlib/libc/string/bzero.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/bzero.c
--- newlib-1.19.0.orig/newlib/libc/string/bzero.c	2002-05-23 20:46:04.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/bzero.c	2011-05-17 07:25:06.789153697 +0200
@@ -6,11 +6,11 @@
 	bzero
 
 ANSI_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	void bzero(void *<[b]>, size_t <[length]>);
 
 TRAD_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	void bzero(<[b]>, <[length]>)
 	void *<[b]>;
 	size_t <[length]>;
@@ -30,7 +30,7 @@
 <<bzero>> requires no supporting OS subroutines.
 */
 
-#include <string.h>
+#include <strings.h>
 
 _VOID
 _DEFUN (bzero, (b, length),
diff -Naur newlib-1.19.0.orig/newlib/libc/string/index.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/index.c
--- newlib-1.19.0.orig/newlib/libc/string/index.c	2000-02-17 20:39:48.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/index.c	2011-05-17 07:25:06.789153697 +0200
@@ -6,11 +6,11 @@
 	index
 
 ANSI_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	char * index(const char *<[string]>, int <[c]>);
 
 TRAD_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	char * index(<[string]>, <[c]>);
 	char *<[string]>;
 	int *<[c]>;
@@ -33,7 +33,8 @@
 	index - pure
 */
 
-#include <string.h>
+#include <strings.h>
+#include <string.h> /* strchr */
 
 char *
 _DEFUN (index, (s, c),
diff -Naur newlib-1.19.0.orig/newlib/libc/string/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/string/Makefile.am	2010-05-11 22:27:20.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/Makefile.am	2011-05-17 07:25:06.788153682 +0200
@@ -71,7 +71,8 @@
 	wmemcmp.c \
 	wmemcpy.c \
 	wmemmove.c \
-	wmemset.c
+	wmemset.c \
+	xpg_strerror_r.c
 
 if ELIX_LEVEL_1
 ELIX_2_SOURCES =
@@ -84,6 +85,7 @@
 	stpncpy.c \
 	strndup.c \
 	strcasestr.c \
+	strchrnul.c \
 	strndup_r.c \
 	wcpcpy.c \
 	wcpncpy.c \
diff -Naur newlib-1.19.0.orig/newlib/libc/string/memccpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memccpy.c
--- newlib-1.19.0.orig/newlib/libc/string/memccpy.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memccpy.c	2011-05-17 07:25:06.789153697 +0200
@@ -35,13 +35,14 @@
 	*/
 
 #include <_ansi.h>
+#include <stdint.h>
 #include <stddef.h>
 #include <string.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the word copy loop.  */
 #define LITTLEBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.19.0.orig/newlib/libc/string/memchr.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memchr.c
--- newlib-1.19.0.orig/newlib/libc/string/memchr.c	2008-05-27 01:31:08.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memchr.c	2011-05-17 07:25:06.790153713 +0200
@@ -38,10 +38,11 @@
 
 #include <_ansi.h>
 #include <string.h>
+#include <stdint.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
-#define UNALIGNED(X) ((long)X & (sizeof (long) - 1))
+#define UNALIGNED(X) ((intptr_t)X & (sizeof (long) - 1))
 
 /* How many bytes are loaded each iteration of the word copy loop.  */
 #define LBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.19.0.orig/newlib/libc/string/memcmp.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memcmp.c
--- newlib-1.19.0.orig/newlib/libc/string/memcmp.c	2005-03-06 21:40:05.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memcmp.c	2011-05-17 07:25:06.790153713 +0200
@@ -37,11 +37,11 @@
 */
 
 #include <string.h>
-
+#include <stdint.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the word copy loop.  */
 #define LBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.19.0.orig/newlib/libc/string/memcpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memcpy.c
--- newlib-1.19.0.orig/newlib/libc/string/memcpy.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memcpy.c	2011-05-17 07:25:06.790153713 +0200
@@ -34,11 +34,12 @@
 	*/
 
 #include <_ansi.h>
+#include <stdint.h>
 #include <string.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the 4X unrolled loop.  */
 #define BIGBLOCKSIZE    (sizeof (long) << 2)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/memmove.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memmove.c
--- newlib-1.19.0.orig/newlib/libc/string/memmove.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memmove.c	2011-05-17 07:25:06.790153713 +0200
@@ -36,13 +36,14 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 #include <_ansi.h>
 #include <stddef.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the 4X unrolled loop.  */
 #define BIGBLOCKSIZE    (sizeof (long) << 2)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/mempcpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/mempcpy.c
--- newlib-1.19.0.orig/newlib/libc/string/mempcpy.c	2010-09-22 05:15:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/mempcpy.c	2011-05-17 07:25:06.790153713 +0200
@@ -34,10 +34,11 @@
 #include <stddef.h>
 #include <limits.h>
 #include <string.h>
+#include <stdint.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((uintptr_t)Y & (sizeof (long) - 1)))
 
 /* How many bytes are copied each iteration of the 4X unrolled loop.  */
 #define BIGBLOCKSIZE    (sizeof (long) << 2)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/memset.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memset.c
--- newlib-1.19.0.orig/newlib/libc/string/memset.c	2008-05-27 20:44:40.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/memset.c	2011-05-17 07:25:06.790153713 +0200
@@ -34,9 +34,10 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 
 #define LBLOCKSIZE (sizeof(long))
-#define UNALIGNED(X)   ((long)X & (LBLOCKSIZE - 1))
+#define UNALIGNED(X)   ((intptr_t)X & (LBLOCKSIZE - 1))
 #define TOO_SMALL(LEN) ((LEN) < LBLOCKSIZE)
 
 _PTR
diff -Naur newlib-1.19.0.orig/newlib/libc/string/rindex.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/rindex.c
--- newlib-1.19.0.orig/newlib/libc/string/rindex.c	2000-02-17 20:39:48.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/rindex.c	2011-05-17 07:25:06.791153729 +0200
@@ -10,7 +10,7 @@
 	char * rindex(const char *<[string]>, int <[c]>);
 
 TRAD_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	char * rindex(<[string]>, <[c]>);
 	char *<[string]>;
 	int *<[c]>;
@@ -33,7 +33,8 @@
 	rindex - pure
 */
 
-#include <string.h>
+#include <strings.h>
+#include <string.h> /* strchr */
 
 char *
 _DEFUN (rindex, (s, c),
diff -Naur newlib-1.19.0.orig/newlib/libc/string/stpcpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/stpcpy.c
--- newlib-1.19.0.orig/newlib/libc/string/stpcpy.c	2007-06-28 19:07:23.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/stpcpy.c	2011-05-17 07:25:06.791153729 +0200
@@ -34,6 +34,7 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 #include <limits.h>
 
 /*SUPPRESS 560*/
@@ -41,7 +42,7 @@
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/stpncpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/stpncpy.c
--- newlib-1.19.0.orig/newlib/libc/string/stpncpy.c	2007-06-28 19:07:23.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/stpncpy.c	2011-05-17 07:25:06.791153729 +0200
@@ -40,6 +40,7 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 #include <limits.h>
 
 /*SUPPRESS 560*/
@@ -47,7 +48,7 @@
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strcasecmp.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcasecmp.c
--- newlib-1.19.0.orig/newlib/libc/string/strcasecmp.c	2009-04-23 20:11:22.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcasecmp.c	2011-05-17 07:25:06.791153729 +0200
@@ -6,11 +6,11 @@
 	strcasecmp
 
 ANSI_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	int strcasecmp(const char *<[a]>, const char *<[b]>);
 
 TRAD_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	int strcasecmp(<[a]>, <[b]>)
 	char *<[a]>;
 	char *<[b]>;
@@ -38,7 +38,7 @@
 	strcasecmp
 */
 
-#include <string.h>
+#include <strings.h>
 #include <ctype.h>
 
 int
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strcat.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcat.c
--- newlib-1.19.0.orig/newlib/libc/string/strcat.c	2000-02-17 20:39:48.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcat.c	2011-05-17 07:25:06.791153729 +0200
@@ -33,12 +33,13 @@
 	strcat ansi pure
 */
 
+#include <stdint.h>
 #include <string.h>
 #include <limits.h>
 
 /* Nonzero if X is aligned on a "long" boundary.  */
 #define ALIGNED(X) \
-  (((long)X & (sizeof (long) - 1)) == 0)
+  (((uintptr_t)X & (sizeof (long) - 1)) == 0)
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strchr.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strchr.c
--- newlib-1.19.0.orig/newlib/libc/string/strchr.c	2008-05-22 04:31:46.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strchr.c	2011-05-17 07:25:06.791153729 +0200
@@ -33,11 +33,12 @@
 	strchr ansi pure
 */
 
+#include <stdint.h>
 #include <string.h>
 #include <limits.h>
 
 /* Nonzero if X is not aligned on a "long" boundary.  */
-#define UNALIGNED(X) ((long)X & (sizeof (long) - 1))
+#define UNALIGNED(X) ((uintptr_t)X & (sizeof (long) - 1))
 
 /* How many bytes are loaded each iteration of the word copy loop.  */
 #define LBLOCKSIZE (sizeof (long))
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strchrnul.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strchrnul.c
--- newlib-1.19.0.orig/newlib/libc/string/strchrnul.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strchrnul.c	2011-05-17 07:25:06.791153729 +0200
@@ -0,0 +1,47 @@
+/*
+FUNCTION
+	<<strchrnul>>---search for character in string
+
+INDEX
+	strchrnul
+
+ANSI_SYNOPSIS
+	#include <string.h>
+	char * strchrnul(const char *<[string]>, int <[c]>);
+
+TRAD_SYNOPSIS
+	#include <string.h>
+	char * strchrnul(<[string]>, <[c]>);
+	const char *<[string]>;
+	int <[c]>;
+
+DESCRIPTION
+	This function finds the first occurence of <[c]> (converted to
+	a char) in the string pointed to by <[string]> (including the
+	terminating null character).
+
+RETURNS
+	Returns a pointer to the located character, or a pointer
+	to the concluding null byte if <[c]> does not occur in <[string]>.
+
+PORTABILITY
+<<strchrnul>> is a GNU extension.
+
+<<strchrnul>> requires no supporting OS subroutines.  It uses
+strchr() and strlen() from elsewhere in this library.
+
+QUICKREF
+	strchrnul
+*/
+
+#include <string.h>
+
+char *
+_DEFUN (strchrnul, (s1, i),
+	_CONST char *s1 _AND
+	int i)
+{
+  char *s = strchr(s1, i);
+
+  return s ? s : (char *)s1 + strlen(s1);
+}
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strcmp.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcmp.c
--- newlib-1.19.0.orig/newlib/libc/string/strcmp.c	2000-02-17 20:39:48.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcmp.c	2011-05-17 07:25:06.792153745 +0200
@@ -35,12 +35,13 @@
 	strcmp ansi pure
 */
 
+#include <stdint.h>
 #include <string.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((uintptr_t)X & (sizeof (long) - 1)) | ((uintptr_t)Y & (sizeof (long) - 1)))
 
 /* DETECTNULL returns nonzero if (long)X contains a NULL byte. */
 #if LONG_MAX == 2147483647L
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strcpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcpy.c
--- newlib-1.19.0.orig/newlib/libc/string/strcpy.c	2007-05-29 23:26:59.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strcpy.c	2011-05-17 07:25:06.792153745 +0200
@@ -32,6 +32,7 @@
 	strcpy ansi pure
 */
 
+#include <stdint.h>
 #include <string.h>
 #include <limits.h>
 
@@ -40,7 +41,7 @@
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strerror.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strerror.c
--- newlib-1.19.0.orig/newlib/libc/string/strerror.c	2009-03-15 14:41:46.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strerror.c	2011-05-17 07:25:06.792153745 +0200
@@ -301,6 +301,17 @@
 result string; therefore portable code cannot depend on the reentrancy
 of this subroutine.
 
+Although this implementation of <<strerror>> guarantees a non-null
+result with a NUL-terminator, some implementations return <<NULL>>
+on failure.  Although POSIX allows <<strerror>> to set <<errno>>
+to EINVAL on failure, this implementation does not do so (unless
+you provide <<_user_strerror>>).
+
+POSIX recommends that unknown <[errnum]> result in a message
+including that value, however it is not a requirement and this
+implementation does not provide that information (unless you
+provide <<_user_strerror>>).
+
 This implementation of <<strerror>> provides for user-defined
 extensibility.  <<errno.h>> defines <[__ELASTERROR]>, which can be
 used as a base for user-defined error values.  If the user supplies a
@@ -313,6 +324,9 @@
 <<_user_strerror>> returns <[NULL]>.  The default <<_user_strerror>>
 returns <[NULL]> for all input values.
 
+Note that <<_user_sterror>> must be thread-safe and not alter <<errno>>
+if <<strerror_r>> is to comply with POSIX.
+
 <<strerror>> requires no supporting OS subroutines.
 
 QUICKREF
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strerror_r.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strerror_r.c
--- newlib-1.19.0.orig/newlib/libc/string/strerror_r.c	2005-10-28 23:21:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strerror_r.c	2011-05-17 07:25:06.792153745 +0200
@@ -1,3 +1,4 @@
+/* GNU variant of strerror_r. */
 /*
 FUNCTION
 	<<strerror_r>>---convert error number to string and copy to buffer
@@ -7,7 +8,11 @@
 
 ANSI_SYNOPSIS
 	#include <string.h>
+	#ifdef _GNU_SOURCE
 	char *strerror_r(int <[errnum]>, char *<[buffer]>, size_t <[n]>);
+	#else
+	int strerror_r(int <[errnum]>, char *<[buffer]>, size_t <[n]>);
+	#endif
 
 TRAD_SYNOPSIS
 	#include <string.h>
@@ -19,35 +24,60 @@
 DESCRIPTION
 <<strerror_r>> converts the error number <[errnum]> into a
 string and copies the result into the supplied <[buffer]> for
-a length up to <[n]>, including the NUL terminator. The value of 
-<[errnum]> is usually a copy of <<errno>>.  If <<errnum>> is not a known 
+a length up to <[n]>, including the NUL terminator. The value of
+<[errnum]> is usually a copy of <<errno>>.  If <<errnum>> is not a known
 error number, the result is the empty string.
 
 See <<strerror>> for how strings are mapped to <<errnum>>.
 
 RETURNS
-This function returns a pointer to a string.  Your application must
-not modify that string.
+There are two variants: the GNU version always returns a NUL-terminated
+string, which is <[buffer]> if all went well, but which is another
+pointer if <[n]> was too small (leaving <[buffer]> untouched).  If the
+return is not <[buffer]>, your application must not modify that string.
+The POSIX version returns 0 on success, <[EINVAL]> if <<errnum>> was not
+recognized, and <[ERANGE]> if <[n]> was too small.  The variant chosen
+depends on macros that you define before inclusion of <<string.h>>.
 
 PORTABILITY
-<<strerror_r>> is a GNU extension.
+<<strerror_r>> with a <[char *]> result is a GNU extension.
+<<strerror_r>> with an <[int]> result is required by POSIX 2001.
+This function is compliant only if <<_user_strerror>> is not provided,
+or if it is thread-safe and does not modify <<errno>>.
+
+POSIX states that the contents of <[buf]> are unspecified on error,
+although this implementation guarantees a NUL-terminated string for
+all except <[n]> of 0.
+
+POSIX recommends that unknown <[errnum]> result in a message including
+that value, however it is not a requirement and this implementation
+provides only an empty string (unless you provide <<_user_strerror>>).
+POSIX also recommends that unknown <[errnum]> fail with EINVAL even
+when providing such a message, however it is not a requirement and
+this implementation will return success if <<_user_strerror>> provided
+a non-empty alternate string.
 
 <<strerror_r>> requires no supporting OS subroutines.
 
 */
 
 #undef __STRICT_ANSI__
+#define _GNU_SOURCE
 #include <errno.h>
 #include <string.h>
+#undef strerror_r
 
+/* For backwards-compatible linking, this must be the GNU signature;
+   see xpg_strerror_r.c for the POSIX version.  */
 char *
 _DEFUN (strerror_r, (errnum, buffer, n),
 	int errnum _AND
 	char *buffer _AND
 	size_t n)
 {
-  char *error;
-  error = strerror (errnum);
+  char *error = strerror (errnum);
 
-  return strncpy (buffer, (const char *)error, n);
+  if (strlen (error) >= n)
+    return error;
+  return strcpy (buffer, error);
 }
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strlen.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strlen.c
--- newlib-1.19.0.orig/newlib/libc/string/strlen.c	2008-05-27 00:56:14.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strlen.c	2011-05-17 07:25:06.792153745 +0200
@@ -32,11 +32,12 @@
 */
 
 #include <_ansi.h>
+#include <stdint.h>
 #include <string.h>
 #include <limits.h>
 
 #define LBLOCKSIZE   (sizeof (long))
-#define UNALIGNED(X) ((long)X & (LBLOCKSIZE - 1))
+#define UNALIGNED(X) ((intptr_t)X & (LBLOCKSIZE - 1))
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strncasecmp.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncasecmp.c
--- newlib-1.19.0.orig/newlib/libc/string/strncasecmp.c	2009-04-23 20:11:22.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncasecmp.c	2011-05-17 07:25:06.792153745 +0200
@@ -6,11 +6,11 @@
 	strncasecmp
 
 ANSI_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	int strncasecmp(const char *<[a]>, const char * <[b]>, size_t <[length]>);
 
 TRAD_SYNOPSIS
-	#include <string.h>
+	#include <strings.h>
 	int strncasecmp(<[a]>, <[b]>, <[length]>)
 	char *<[a]>;
 	char *<[b]>;
@@ -40,7 +40,7 @@
 	strncasecmp
 */
 
-#include <string.h>
+#include <strings.h>
 #include <ctype.h>
 
 int 
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strncat.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncat.c
--- newlib-1.19.0.orig/newlib/libc/string/strncat.c	2005-10-28 23:21:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncat.c	2011-05-17 07:25:06.793153761 +0200
@@ -42,11 +42,12 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 #include <limits.h>
 
 /* Nonzero if X is aligned on a "long" boundary.  */
 #define ALIGNED(X) \
-  (((long)X & (sizeof (long) - 1)) == 0)
+  (((intptr_t)X & (sizeof (long) - 1)) == 0)
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strncmp.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncmp.c
--- newlib-1.19.0.orig/newlib/libc/string/strncmp.c	2000-02-17 20:39:48.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncmp.c	2011-05-17 07:25:06.793153761 +0200
@@ -36,12 +36,13 @@
 	strncmp ansi pure
 */
 
+#include <stdint.h>
 #include <string.h>
 #include <limits.h>
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((uintptr_t)X & (sizeof (long) - 1)) | ((uintptr_t)Y & (sizeof (long) - 1)))
 
 /* DETECTNULL returns nonzero if (long)X contains a NULL byte. */
 #if LONG_MAX == 2147483647L
diff -Naur newlib-1.19.0.orig/newlib/libc/string/strncpy.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncpy.c
--- newlib-1.19.0.orig/newlib/libc/string/strncpy.c	2000-02-17 20:39:48.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/strncpy.c	2011-05-17 07:25:06.793153761 +0200
@@ -38,6 +38,7 @@
 */
 
 #include <string.h>
+#include <stdint.h>
 #include <limits.h>
 
 /*SUPPRESS 560*/
@@ -45,7 +46,7 @@
 
 /* Nonzero if either X or Y is not aligned on a "long" boundary.  */
 #define UNALIGNED(X, Y) \
-  (((long)X & (sizeof (long) - 1)) | ((long)Y & (sizeof (long) - 1)))
+  (((intptr_t)X & (sizeof (long) - 1)) | ((intptr_t)Y & (sizeof (long) - 1)))
 
 #if LONG_MAX == 2147483647L
 #define DETECTNULL(X) (((X) - 0x01010101) & ~(X) & 0x80808080)
diff -Naur newlib-1.19.0.orig/newlib/libc/string/xpg_strerror_r.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/xpg_strerror_r.c
--- newlib-1.19.0.orig/newlib/libc/string/xpg_strerror_r.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/string/xpg_strerror_r.c	2011-05-17 07:25:06.793153761 +0200
@@ -0,0 +1,25 @@
+/* POSIX variant of strerror_r. */
+#undef __STRICT_ANSI__
+#include <errno.h>
+#include <string.h>
+
+int
+_DEFUN (__xpg_strerror_r, (errnum, buffer, n),
+	int errnum _AND
+	char *buffer _AND
+	size_t n)
+{
+  char *error;
+
+  if (!n)
+    return ERANGE;
+  error = strerror (errnum);
+  if (strlen (error) >= n)
+    {
+      memcpy (buffer, error, n - 1);
+      buffer[n - 1] = '\0';
+      return ERANGE;
+    }
+  strcpy (buffer, error);
+  return *error ? 0 : EINVAL;
+}
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/linux/Makefile.am newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/linux/Makefile.am
--- newlib-1.19.0.orig/newlib/libc/sys/linux/Makefile.am	2009-08-19 22:04:43.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/linux/Makefile.am	2011-05-17 07:25:06.793153761 +0200
@@ -72,7 +72,6 @@
 	process.c \
 	prof-freq.c \
 	profile.c \
-	psignal.c \
 	pwrite.c \
 	raise.c \
 	realloc.c \
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/linux/sys/signal.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/linux/sys/signal.h
--- newlib-1.19.0.orig/newlib/libc/sys/linux/sys/signal.h	2002-07-24 20:18:07.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/linux/sys/signal.h	2011-05-17 07:25:06.794153777 +0200
@@ -37,7 +37,6 @@
 #include <_ansi.h>
 
 int 	_EXFUN(kill, (int, int));
-_VOID 	_EXFUN(psignal, (int, const char *));
 int 	_EXFUN(sigaction, (int, const struct sigaction *, struct sigaction *));
 int 	_EXFUN(sigaddset, (sigset_t *, const int));
 int 	_EXFUN(sigdelset, (sigset_t *, const int));
@@ -50,7 +49,6 @@
 
 #ifndef _POSIX_SOURCE
 extern const char *const sys_siglist[];
-typedef __sighandler_t sig_t; /* BSDism */
 #endif
 
 #endif
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/rtems/crt0.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/rtems/crt0.c
--- newlib-1.19.0.orig/newlib/libc/sys/rtems/crt0.c	2009-12-16 19:28:14.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/rtems/crt0.c	2011-05-17 07:25:06.794153777 +0200
@@ -24,8 +24,8 @@
 /* RTEMS provides some of its own routines including a Malloc family */
 RTEMS_STUB(void *,malloc(size_t s)) { return 0; }
 RTEMS_STUB(void *,realloc(void* p, size_t s)) { return 0; }
-RTEMS_STUB(void, free(void)) { ; }
-RTEMS_STUB(_PTR, calloc(struct _reent *r, size_t s1, size_t s2)) {}
+RTEMS_STUB(void, free(void* ptr)) { ; }
+RTEMS_STUB(_PTR, calloc(size_t s1, size_t s2)) {}
 
 #if defined(__GNUC__)
 /*
@@ -49,6 +49,7 @@
 #endif
 
 /* stubs for functions RTEMS provides */
+RTEMS_STUB(int, clock_gettime(clockid_t clk_id, struct timespec *tp)) { return -1; }
 RTEMS_STUB(int, close (int fd)) { return -1; }
 RTEMS_STUB(int, dup2(int oldfd, int newfd)) { return -1; }
 RTEMS_STUB(int, fcntl( int fd, int cmd, ... /* arg */ )) { return -1; }
@@ -56,6 +57,7 @@
 RTEMS_STUB(int, fstat(int fd, struct stat *buf)) { return -1; }
 RTEMS_STUB(int, getdents(int fd, void *dp, int count)) { return -1; }
 RTEMS_STUB(char *, getlogin(void)) { return 0; }
+RTEMS_STUB(int, gettimeofday(struct timeval *tv, struct timezone *tz)) { return -1; }
 RTEMS_STUB(struct passwd *, getpwnam(const char *name)) { return 0; }
 RTEMS_STUB(struct passwd *, getpwuid(uid_t uid)) { return 0; }
 RTEMS_STUB(uid_t, getuid(void)) { return 0; }
@@ -65,6 +67,7 @@
 RTEMS_STUB(int, open(const char *pathname, int flags, int mode)) { return -1; }
 RTEMS_STUB(int, pipe(int pipefd[2])) { return -1; }
 RTEMS_STUB(_ssize_t, read(int fd, void *buf, size_t count)) { return -1; }
+RTEMS_STUB(int, sched_yield(void)) { return -1; }
 RTEMS_STUB(int, sigfillset(sigset_t *set)) { return -1; }
 RTEMS_STUB(int, sigprocmask(int how, const sigset_t *set, sigset_t *oldset)) { return -1; }
 RTEMS_STUB(int, stat(const char *path, struct stat *buf)) { return -1; }
@@ -95,7 +98,7 @@
 RTEMS_STUB(int, _kill_r (struct _reent *r, int pid, int sig )) { return -1; }
 #if !defined(REENTRANT_SYSCALLS_PROVIDED)
 /* cf. newlib/libc/reent/linkr.c */
-RTEMS_STUB(int, _link_r (struct _reent *, const char *, const char *)) { return -1; }
+RTEMS_STUB(int, _link_r (struct _reent *r, const char *oldpath, const char *newpath)) { return -1; }
 #endif
 RTEMS_STUB(_off_t, _lseek_r ( struct _reent *ptr, int fd, _off_t offset, int whence )) { return -1; }
 RTEMS_STUB(int, _open_r (struct _reent *r, const char *buf, int flags, int mode)) { return -1; }
@@ -103,14 +106,14 @@
 RTEMS_STUB(int, _rename_r (struct _reent *r, const char *a, const char *b)){ return -1; }
 #if !(defined (REENTRANT_SYSCALLS_PROVIDED) || defined (MALLOC_PROVIDED))
 /* cf. newlib/libc/reent/sbrkr.c */
-RTEMS_STUB(void *,_sbrk_r (struct _reent *r, ptrdiff_t)) { return -1; }
+RTEMS_STUB(void *,_sbrk_r (struct _reent *r, ptrdiff_t addr)) { return 0; }
 #endif
 RTEMS_STUB(int, _stat_r (struct _reent *r, const char *path, struct stat *buf)) { return -1; }
 RTEMS_STUB(_CLOCK_T_, _times_r (struct _reent *r, struct tms *ptms)) { return -1; }
 RTEMS_STUB(int, _unlink_r (struct _reent *r, const char *path)) { return -1; }
 #if !(defined (REENTRANT_SYSCALLS_PROVIDED) || defined (NO_EXEC))
 /* cf. newlib/libc/reent/execr.c */
-RTEMS_STUB(int, _wait_r (struct _reent *r, int *)) { return -1; }
+RTEMS_STUB(int, _wait_r (struct _reent *r, int *status)) { return -1; }
 #endif
 RTEMS_STUB(_ssize_t, _write_r (struct _reent *r, int fd, const void *buf, size_t nbytes)) { return -1; }
 
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/rtems/include/limits.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/rtems/include/limits.h
--- newlib-1.19.0.orig/newlib/libc/sys/rtems/include/limits.h	2008-11-17 23:05:12.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/rtems/include/limits.h	2011-05-17 07:25:06.795153792 +0200
@@ -78,7 +78,13 @@
  *  Invariant values
  */
 
+#ifdef __SIZE_MAX__
+#define SSIZE_MAX		(__SIZE_MAX__ >> 1)
+#elif defined(__SIZEOF_SIZE_T__) && defined(__CHAR_BIT__)
+#define SSIZE_MAX               ((1UL << (__SIZEOF_SIZE_T__ * __CHAR_BIT__ - 1)) - 1)
+#else /* historic fallback, wrong in most cases */
 #define SSIZE_MAX               32767
+#endif
 
 /*
  *  Maximum Values
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/rtems/sys/dirent.h newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/rtems/sys/dirent.h
--- newlib-1.19.0.orig/newlib/libc/sys/rtems/sys/dirent.h	2010-07-06 17:23:27.000000000 +0200
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/rtems/sys/dirent.h	2011-05-17 07:25:06.795153792 +0200
@@ -50,7 +50,7 @@
 
 int scandir ( const char *dirname,
    struct dirent *** namelist,
-   int (*select)(struct dirent *),
+   int (*select)(const struct dirent *),
    int (*dcomp)(const struct dirent **, const struct dirent **)
 );
 
diff -Naur newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/fstat.c newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/fstat.c
--- newlib-1.19.0.orig/newlib/libc/sys/sysnecv850/fstat.c	2000-02-17 20:39:50.000000000 +0100
+++ newlib-1.19.0-rtems4.11-20110517/newlib/libc/sys/sysnecv850/fstat.c	2011-05-17 07:25:06.795153792 +0200
@@ -13,6 +13,5 @@
 _fstat (int file,
 	struct stat *st)
 {
-  st->st_mode = S_IFCHR;
-  return 0;
+  return TRAP0 (SYS_fstat, file, st, 0);
 }
